# -*- coding: utf-8 -*-
from setuphelpers import *

uninstallkey = []
reset        = True


def install():
    # profile settings
    print("Set the user data directory")
    registry_setstring(HKEY_LOCAL_MACHINE, r"SOFTWARE\Policies\Microsoft\Edge",'UserDataDir',"${local_app_data}\Edge\Profile", type=REG_SZ)
    print("Set the use of copies of roaming data of the current user")
    registry_setstring(HKEY_LOCAL_MACHINE, r"SOFTWARE\Policies\Microsoft\Edge",'RoamingProfileSupportEnabled',1, type=REG_DWORD)

    # edge update settings
    print("Set that a Microsoft Edge channel can be installed on domain-joined devices")
    registry_setstring(HKEY_LOCAL_MACHINE, r"SOFTWARE\Policies\Microsoft\EdgeUpdate",'Install{56EB18F8-B008-4CBD-B6D2-8C97FE7E9062}',1, type=REG_DWORD)
    print("Specifies that Microsoft Edge Update should rollback installations of Microsoft Edge to the version indicated in Target version override")
    registry_setstring(HKEY_LOCAL_MACHINE, r"SOFTWARE\Policies\Microsoft\EdgeUpdate",'RollbackToTargetVersion{56EB18F8-B008-4CBD-B6D2-8C97FE7E9062}',1, type=REG_DWORD)
    print("If auto-update is enabled, Microsoft Edge will be updated to the version specified by this policy value")
    registry_setstring(HKEY_LOCAL_MACHINE, r"SOFTWARE\Policies\Microsoft\EdgeUpdate",'TargetVersionPrefix{56EB18F8-B008-4CBD-B6D2-8C97FE7E9062}',"93.0.961.38", type=REG_SZ)
    print("Disable auto-update")
    registry_setstring(HKEY_LOCAL_MACHINE, r"SOFTWARE\Policies\Microsoft\EdgeUpdate",'Update{56EB18F8-B008-4CBD-B6D2-8C97FE7E9062}',0, type=REG_DWORD)


def uninstall():
    if reset:
        if reg_value_exists(HKEY_LOCAL_MACHINE, r"SOFTWARE\Policies\Microsoft\Edge",'UserDataDir'):
            print("Unset the user data directory")
            registry_delete(HKEY_LOCAL_MACHINE, r"SOFTWARE\Policies\Microsoft\Edge",'UserDataDir')

        if reg_value_exists(HKEY_LOCAL_MACHINE, r"SOFTWARE\Policies\Microsoft\Edge",'RoamingProfileSupportEnabled'):
            print("Unset the use of copies of roaming data of the current user")
            registry_delete(HKEY_LOCAL_MACHINE, r"SOFTWARE\Policies\Microsoft\Edge",'RoamingProfileSupportEnabled')

        if reg_value_exists(HKEY_LOCAL_MACHINE, r"SOFTWARE\Policies\Microsoft\EdgeUpdate",'Install{56EB18F8-B008-4CBD-B6D2-8C97FE7E9062}'):
            print("Unset that a Microsoft Edge channel can be installed on domain-joined devices")
            registry_delete(HKEY_LOCAL_MACHINE, r"SOFTWARE\Policies\Microsoft\EdgeUpdate",'Install{56EB18F8-B008-4CBD-B6D2-8C97FE7E9062}')

        if reg_value_exists(HKEY_LOCAL_MACHINE, r"SOFTWARE\Policies\Microsoft\EdgeUpdate",'RollbackToTargetVersion{56EB18F8-B008-4CBD-B6D2-8C97FE7E9062}'):
            print("Specifies that Microsoft Edge Update should not rollback installations of Microsoft Edge to the version indicated in Target version override")
            registry_delete(HKEY_LOCAL_MACHINE, r"SOFTWARE\Policies\Microsoft\EdgeUpdate",'RollbackToTargetVersion{56EB18F8-B008-4CBD-B6D2-8C97FE7E9062}')

        if reg_value_exists(HKEY_LOCAL_MACHINE, r"SOFTWARE\Policies\Microsoft\EdgeUpdate",'TargetVersionPrefix{56EB18F8-B008-4CBD-B6D2-8C97FE7E9062}'):
            print("Deactivate targetted version of edge")
            registry_delete(HKEY_LOCAL_MACHINE, r"SOFTWARE\Policies\Microsoft\EdgeUpdate",'TargetVersionPrefix{56EB18F8-B008-4CBD-B6D2-8C97FE7E9062}')

        if reg_value_exists(HKEY_LOCAL_MACHINE, r"SOFTWARE\Policies\Microsoft\EdgeUpdate",'Update{56EB18F8-B008-4CBD-B6D2-8C97FE7E9062}'):
            print("Reactivate auto-update")
            registry_delete(HKEY_LOCAL_MACHINE, r"SOFTWARE\Policies\Microsoft\EdgeUpdate",'Update{56EB18F8-B008-4CBD-B6D2-8C97FE7E9062}')
    else:
        print("No reset of previous settings")


